# 3.5.21. sourcestamp

resource type: sourcestamp
  Attributes:

    - ssid (integer) –

      the ID of this sourcestamp

      Note

      For legacy reasons, the abbreviated name `ssid` is used instead of canonical `sourcestampid`. This might change in the future (bug #3509).

    - branch? (string) – code branch, or none for the “default branch”, whatever that might mean

    - codebase (string) – revision for this sourcestamp, or none if unknown

    - created_at (date) – the timestamp when this sourcestamp was created

    - patch? (patch) – the patch for this sourcestamp, or none

    - project (string) – user-defined project to which this sourcestamp corresponds

    - repository (string) – repository where this sourcestamp occurred

    - revision? (string) – revision for this sourcestamp, or none if unknown

A sourcestamp represents a particular version of the source code. Absolute sourcestamps specify this completely, while relative sourcestamps (with revision = None) specify the latest source at the current time. Source stamps can also have patches; such stamps describe the underlying revision with the given patch applied.

Note that depending on the underlying version-control system, the same revision may describe different code in different branches (e.g., SVN) or may be independent of the branch (e.g., Git).

The `created_at` timestamp can be used to indicate the first time a sourcestamp was seen by Buildbot. This provides a reasonable default ordering for sourcestamps when more reliable information is not available.

## 3.5.21.1. Endpoints

path: /sourcestamps

This path selects all sourcestamps (can return lots of data!)

`GET`
  `returns`

    `collection` of `sourcestamp`

path: /sourcestamps/{ssid}
  Path Keys:

    ssid (number) – the id of the sourcestamp

This path selects one sourcestamp by id

`GET`
  `returns`

    `collection` of `sourcestamp`